import javax.microedition.midlet.* ;
import javax.microedition.lcdui.* ;
import com.j_phone.ui.FEPControl ;



public class  Config  extends Canvas implements  CommandListener {
	private view  vv ;
	private static final String[] list = {
		"s(0-9)","tHgTCY","c\ɕύX","sӏɋs}","펞obNCg","őǍs(1-10)","őҏW(10-120KB)",
		"FR(0-255)","FG(0-255)","FB(0-255)", "wiFR(0-255)","wiFG(0-255)","wiFB(0-255)",
		"󃁃(ύXs)","(ύXs)","lɖ߂"} ;
	private static final String[] fontstring = {"SMALL()","MEDIUM()","LARGE()"} ;
	private int currentFocus ;
	private int currentDisplay ;
	private long memorysize, totalmemorysize ;
	private int  lineh, fontsize, maxloadline, editmaxline ;
	private int  backcolor_r, backcolor_g, backcolor_b, textcolor_r, textcolor_g, textcolor_b ;
	private boolean paragraphenter, keepbl, tategaki ;

	public  Config( view v){
		vv = v ;
		currentFocus = currentDisplay = 0 ;
		totalmemorysize = Runtime.getRuntime().totalMemory() ;
		addCommand( new Command( "OK", Command.SCREEN, 19)) ;
		addCommand( new Command( "CANCEL", Command.SCREEN, 18)) ;
		setCommandListener( this) ;
	}

	public void init(){
		memorysize = Runtime.getRuntime().freeMemory() ;
		lineh=vv.lineh-vv.font.getHeight() ;
		maxloadline=vv.maxloadline; paragraphenter=vv.paragraphenter; keepbl=vv.keepbl;editmaxline=vv.editmaxline/1024;tategaki=vv.tategaki;
		backcolor_b = vv.backcolor%256 ; backcolor_g=(vv.backcolor/256)%256 ; backcolor_r=(vv.backcolor/65536)%256 ;
		textcolor_b = vv.textcolor%256 ; textcolor_g=(vv.textcolor/256)%256 ; textcolor_r=(vv.textcolor/65536)%256 ;
		switch( vv.font.getSize()){
			case Font.SIZE_LARGE:
				fontsize=2;
				break;
			case Font.SIZE_MEDIUM:
				fontsize=1;
				break;
			case Font.SIZE_SMALL:
			default :
				fontsize=0;
				break;
		}
		return ;
	}

	public void paint( Graphics g){
		g.setFont( vv.smallfont) ;
		g.setColor( vv.backcolor) ;
		g.fillRect( 0, 0, vv.width, vv.height) ;
		g.setColor(16743551) ; // 
		g.fillRect( 0, (currentFocus-currentDisplay)*vv.footheight+vv.footheight, vv.width, vv.footheight) ;
		g.setColor(12566463) ; // D
		g.fillRect( 0, 0, vv.width, vv.footheight) ;
		g.setColor( 0) ; // 
		g.drawString( "ݒ", 0, 0, g.TOP|g.LEFT) ;
		g.drawString( currentFocus+"/"+(list.length-1), vv.width, 0, g.TOP|g.RIGHT) ;
		g.setColor( vv.textcolor) ;
		for( int i=0; i<list.length&&i<vv.maxlinesmall-1; i++){
			g.drawString( list[i+currentDisplay], 0, i*vv.footheight+vv.footheight, g.TOP|g.LEFT) ;
			g.drawString( getSetting(i+currentDisplay), vv.width, i*vv.footheight+vv.footheight, g.TOP|g.RIGHT) ;
		}
		return ;
	}

	public void  keyRepeated(int keyCode){
		keyPressed( keyCode) ;
	}
	public void  keyPressed(int keyCode){
		switch( keyCode){
			case  UP :
				if( currentFocus>=1){
					currentFocus--;
					if(!isFocusDisplay()){
						currentDisplay = currentFocus ;
					}
					break ;
				}
				return ;
			case  DOWN :
				if( currentFocus<list.length-1){
					currentFocus++;
					if(!isFocusDisplay()){
						currentDisplay = currentFocus-vv.maxlinesmall+1 ;
					}
					break ;
				}
				return ;
			case  LEFT :
				switch(currentFocus){
					case  0 :
						lineh=(lineh+9)%10 ;
						break ;
					case  1 :
						fontsize=(fontsize+2)%3 ;
						break ;
					case  2 :
						tategaki^=true ;
						break ;
					case  3 :
						paragraphenter^=true ;
						break ;
					case  4 :
						keepbl^=true ;
						break ;
					case  6 :
						if( editmaxline<=10){
							editmaxline=120;
						} else {
							editmaxline--;
						}
						break ;
					default :
						return ;
				}
				break;
			case  RIGHT :
			case  FIRE :
				switch (currentFocus){
					case  0 :
						lineh=(lineh+1)%10 ;
						break ;
					case  1 :
						fontsize=(fontsize+1)%3 ;
						break ;
					case  2 :
						tategaki^=true ;
						break ;
					case  3 :
						paragraphenter^=true ;
						break ;
					case  4 :
						keepbl^=true ;
						break ;
					case  6 :
						if( editmaxline>=120){
							editmaxline=10;
						} else {
							editmaxline++;
						}
						break ;
					case 15 :
						lineh = 2 ;
						maxloadline = 14999 ;
						paragraphenter = keepbl = tategaki = false ;
						backcolor_b = backcolor_g = backcolor_r = 255 ;
						textcolor_b = textcolor_g = textcolor_r = 0 ;
						fontsize = 0 ;
						editmaxline = 40960/1024;
						break ;
					default:
						return ;
				}
				break ;
			default:
				return ;
		}
		repaint() ;
		return ;
	}
	public void  keyReleased(int keyCode){
		if( keyCode!=FIRE && keyCode!=RIGHT){
			return ;
		}
		switch (currentFocus){
			case  5 :
				try {
					maxloadline = Integer.parseInt( vv.fep.getInputText( maxloadline+"", TextField.NUMERIC, 5, false)) ;
					if( maxloadline<1000||maxloadline>=100000){
						maxloadline = 14999 ;
					}
				}catch( Exception e){
					maxloadline = 14999 ;
				}
				break ;
			case  7 :
				textcolor_r = getInputColor(textcolor_r) ;
				break ;
			case  8 :
				textcolor_g = getInputColor(textcolor_g) ;
				break ;
			case  9 :
				textcolor_b = getInputColor(textcolor_b) ;
				break ;
			case 10 :
				backcolor_r = getInputColor(backcolor_r) ;
				break ;
			case 11 :
				backcolor_g = getInputColor(backcolor_g) ;
				break ;
			case 12 :
				backcolor_b = getInputColor(backcolor_b) ;
				break ;
			default :
				return ;
		}
		repaint();
		return ;
	}
	public void commandAction( Command cmd, Displayable d){
		if(cmd != List.SELECT_COMMAND){
			switch( cmd.getPriority()){
				case  19 :
					if( checkColor()){
						List lt = new List("PIƔwi̐F߂̂ŏFɐݒ肵܂I", Choice.IMPLICIT) ;
						lt.append("[[cOB", null) ;
						lt.setCommandListener(this) ;
						Display.getDisplay(vv.mld).setCurrent(lt) ;
						textcolor_r=textcolor_g=textcolor_b=0;
						backcolor_r=backcolor_g=backcolor_b=255;
						return ;
					}
					break ;
				case  18 :
					Display.getDisplay(vv.mld).setCurrent(vv) ;
					vv.blOn() ;
					return ;
				default :
					return ;
			}
		}
		fixConfig() ;
		vv.saveConfig();
		vv.loadFile();
		Display.getDisplay(vv.mld).setCurrent(vv) ;
		return ;
	}

	private boolean isFocusDisplay(){
		if( currentFocus<currentDisplay || currentDisplay+vv.maxlinesmall-1<currentFocus){
			return  false ;
		} else {
			return  true ;
		}
	}
	private void fixConfig(){
		vv.maxloadline = maxloadline ; vv.paragraphenter = paragraphenter;vv.keepbl=keepbl ;vv.tategaki=tategaki;vv.editmaxline=editmaxline*1024;
		vv.textcolor = (textcolor_r*256+textcolor_g)*256+textcolor_b ;
		vv.backcolor = (backcolor_r*256+backcolor_g)*256+backcolor_b ;
		switch(fontsize){
			case  0 :
			default :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_SMALL) ;
				break ;
			case  1 :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_MEDIUM) ;
				break ;
			case  2 :
				vv.font = Font.getFont( Font.FACE_SYSTEM,  Font.STYLE_PLAIN,  Font.SIZE_LARGE) ;
				break ;
		}
		vv.lineh = lineh+vv.font.getHeight() ;
		vv.setMaxline() ;
		return ;
	}
	private String getSetting(int index){
		switch( index){
			case  0 :
				return  lineh+"";
			case  1 :
				return  fontstring[fontsize] ;
			case  2 :
				return  getYN(tategaki) ;
			case  3 :
				return  getYN(paragraphenter) ;
			case  4 :
				return  getYN(keepbl) ;
			case  5 :
				return  maxloadline+"";
			case  6 :
				return  editmaxline+"";
			case  7 :
				return  textcolor_r+"" ;
			case  8 :
				return  textcolor_g+"" ;
			case  9 :
				return  textcolor_b+"" ;
			case 10 :
				return  backcolor_r+"" ;
			case 11 :
				return  backcolor_g+"" ;
			case 12 :
				return  backcolor_b+"" ;
			case 13 :
				return  memorysize+"" ;
			case 14 :
				return  totalmemorysize+"" ;
			case 15 :
				return  "s!" ;
			default :
				return "nullpo" ;
		}
	}
	private String getYN(boolean l){
		if(l){
			return  "͂" ;
		} else {
			return  "" ;
		}
	}
	private int getInputColor(int base){
		try {
			int tmp = Integer.parseInt( vv.fep.getInputText( base+"", TextField.NUMERIC, 3, false)) ;
			if( tmp<0||tmp>255){
				return  base ;
			} else {
				return  tmp ;
			}
		}catch( Exception e){
			return  base ;
		}
	}
	private boolean checkColor(){
		if( Math.abs(textcolor_r-backcolor_r)+Math.abs(textcolor_g-backcolor_g)+Math.abs(textcolor_b-backcolor_b) < 64){
			return  true ;
		} else {
			return  false ;
		}
	}
}
